require 'open-uri'
require 'json'

# 検索ワードを渡してWikipediaで検索するクラス
class WikipediaSearcher
  # Wikipediaの検索用URL
  BASE_URL = 'https://ja.wikipedia.org/w/api.php?format=json&action=query&list=search&srsearch=' # srsearchの後に検索ワードを指定
  # search_wordで検索したい語を指定する
  def initialize(search_word)
    @request_url = BASE_URL + search_word
  end

  def search
    # APIにアクセス
    response = open(@request_url).read

    # JSON形式のテキストをハッシュに変換
    hash = JSON.parse(response)

    # 検索結果の中ではじめにヒットしたものを表示。
    hash['query']['search'][0] # 検索結果を一覧で表示したい場合は[0]を省略。
  end
end

searcher = WikipediaSearcher.new('ruby') # rubyで検索する
p searcher.search
